var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var fs = require('fs');
var path = require('path');
var xml2js = require('xml2js');
//TODO: require('package.json') refered to WFS path not this module's.
//      consider to change the module path
var PLUGIN_NAME = 'clockface';
var CLOCKFACE_PACKAGE_NAME = 'com.samsung.android.app.clockface';
var CLOCKFACE_WFS_ACTIVITY_NAME = "".concat(CLOCKFACE_PACKAGE_NAME, "/").concat(CLOCKFACE_PACKAGE_NAME, ".setting.WFSSetterActivity");
var CLOCKFACE_INTENT_BUNDLE_KEY_PACKAGE_NAME = 'watch_package_name';
var PRELOADED_RUNTIME_PATH = path.join(wfsUtil.getSystemPath('userData'), 'plugins', "".concat(PLUGIN_NAME), 'runtime');
var PRELOADED_WFS_SAMPLES_PATH = path.join(wfsUtil.getSystemPath('userData'), 'plugins', "".concat(PLUGIN_NAME), 'wfs_samples');
var RUNTIME_PLUGIN_PATH = path.join(wfsUtil.getSystemPath('userData'), 'plugins', 'runtime');
//Moved to Manifest
//CLOCKFACE constant
var CATEGORY_AOD = 1 << 0;
var CATEGORY_LOCKSCREEN = 1 << 1;
var CATEGORY_SUB_SCREEN = 1 << 2;
var CATEGORY_SUB_LAUNCHER = 1 << 3;
var CLOCKFACE_DISPLAY_TYPE_KEY_NAME = 'com.samsung.watchface.target.category';
var CLOCKFACE_DISPLAY_TYPE_Z_FLIP_4_VALUE = CATEGORY_SUB_SCREEN;
var CLOCKFACE_DISPLAY_TYPE_Z_FLIP_5_VALUE = CATEGORY_SUB_LAUNCHER;
var installPreloadedRuntime = function () {
    console.log('installPreloadedRuntime');
    if (fs.existsSync(PRELOADED_RUNTIME_PATH)) {
        fs.cpSync(PRELOADED_RUNTIME_PATH, RUNTIME_PLUGIN_PATH, {
            force: true,
            recursive: true,
        });
    }
    else {
        console.log('PRELOADED_RUNTIME_PATH is invalid. PATH:', PRELOADED_RUNTIME_PATH);
    }
};
var makeReadOnlySamples = function () {
    try {
        var sampleProjects = fs.readdirSync(PRELOADED_WFS_SAMPLES_PATH);
        sampleProjects.forEach(function (project) {
            var src = path.join(PRELOADED_WFS_SAMPLES_PATH, project);
            fs.chmodSync(src, 292);
        });
    }
    catch (err) {
        console.log('Permission modified fail.' + err);
    }
};
var uninstallPreloadedRuntime = function () {
    console.log('uninstallPreloadedRuntime');
    fs.existsSync(RUNTIME_PLUGIN_PATH) && fs.rmdirSync(RUNTIME_PLUGIN_PATH, { recursive: true });
};
var plugInFilePath = {
    baseManifest: path.join(RUNTIME_PLUGIN_PATH, 'base', 'merged-manifest', 'AndroidManifest.xml'),
    editableManifest: '',
    androidJar: '',
    flats: '',
    stableIDs: '',
    classes: '',
    mergedNativeLibs: '',
};
var updateManifest = function (editable, properties) {
    return new Promise(function (resolve) { return __awaiter(void 0, void 0, void 0, function () {
        var baseManifestPath, xml, parser;
        return __generator(this, function (_a) {
            if (editable) {
                baseManifestPath = plugInFilePath.editableManifest;
            }
            else {
                baseManifestPath = plugInFilePath.baseManifest;
            }
            xml = fs.readFileSync(baseManifestPath, 'utf-8');
            parser = new xml2js.Parser();
            parser.parseString(xml, function (err, result) {
                if (result.manifest['uses-feature']) {
                    for (var i = 0; i < result.manifest['uses-feature'].length; i++) {
                        if (result.manifest['uses-feature'][i].$['android:name'] === 'android.hardware.type.watch') {
                            result.manifest['uses-feature'].splice(i, 1);
                        }
                    }
                }
                if (!result.manifest.application[0]['property'])
                    result.manifest.application[0]['property'] = [];
                properties.forEach(function (property) {
                    var find = false;
                    for (var i = 0; i < result.manifest.application[0]['property'].length; i++) {
                        if (result.manifest.application[0]['property'][i].$['android:name'] === property.key) {
                            result.manifest.application[0]['property'][i].$['android:value'] = property.value;
                            find = true;
                        }
                    }
                    if (!find) {
                        result.manifest.application[0]['property'].push({
                            $: { 'android:name': property.key, 'android:value': property.value },
                        });
                    }
                });
                var builder = new xml2js.Builder();
                var xml = builder.buildObject(result);
                // write updated XML string to a file
                fs.writeFile(baseManifestPath, xml, function () {
                    console.log("Updated AndroidManifest.xml is updated");
                    fs.chmodSync(baseManifestPath, fs.constants.S_IRUSR |
                        fs.constants.S_IWUSR |
                        fs.constants.S_IXUSR |
                        fs.constants.S_IRGRP |
                        fs.constants.S_IROTH);
                    resolve();
                });
            });
            return [2 /*return*/];
        });
    }); });
};
//////////////////////////// SettingBucket ////////////////////////////
var ZFLIP_SERIES = ['Z Flip4', 'Z Flip5'];
var HINT_TYPE = 'CoverScreen';
var MODEL_INFO = {
    'Z Flip4': {
        width: 520,
        height: 260,
        hints: {
            MODEL: 'Galaxy Z Flip4',
            TYPE: HINT_TYPE,
            DISPLAY_TYPE: 'CoverScreen',
        },
        propertyData: {
            key: CLOCKFACE_DISPLAY_TYPE_KEY_NAME,
            value: CLOCKFACE_DISPLAY_TYPE_Z_FLIP_4_VALUE,
        },
        modelName: ['b4q', 'b2q'],
        versionOneUI: 50101,
    },
    //display metric : 748 x 654, physical size : 748 x 720
    'Z Flip5': {
        width: 748,
        height: 720,
        hints: {
            MODEL: 'Galaxy Z Flip5',
            TYPE: HINT_TYPE,
            DISPLAY_TYPE: 'CoverScreen',
        },
        propertyData: {
            key: CLOCKFACE_DISPLAY_TYPE_KEY_NAME,
            value: CLOCKFACE_DISPLAY_TYPE_Z_FLIP_5_VALUE,
        },
        modelName: ['b5q'],
        versionOneUI: 50101,
    },
};
function getBucket(id) {
    var info = MODEL_INFO[id];
    return {
        id: id,
        name: "Galaxy ".concat(id),
        pluginName: "".concat(PLUGIN_NAME),
        profile: 'mobile',
        shape: 'rectangle',
        width: info.width,
        height: info.height,
        cornerRadius: { x: 40, y: 40 },
        previewImagePath: '',
        shapeBoundsOnSkin: {
            x: 0,
            y: 0,
            width: info.width,
            height: info.height,
        },
        deviceSkinPath: [],
        hints: info.hints,
    };
}
var zFlipInfos = {
    'Z Flip5': {
        bucket: getBucket('Z Flip5'),
    },
    'Z Flip4': {
        bucket: getBucket('Z Flip4'),
    },
};
var buckets = Object.values(zFlipInfos).map(function (zflip) { return zflip.bucket; });
var onProjectOpened = function () {
    if (wfsSetting.getDeviceProfile() === 'mobile') {
        console.log('onProjectOpened');
    }
    return;
};
var onProjectClosed = function () {
    if (wfsSetting.getDeviceProfile() === 'mobile') {
        console.log('onProjectClosed');
    }
    return;
};
var onRunOnDeviceStarted = function (currentData) { return function (rodStartData) {
    if (wfsSetting.getDeviceProfile() === 'mobile') {
        console.log('onRunOnDeviceStarted');
        var size_1 = wfsSetting.getDeviceSize();
        var model = Object.entries(MODEL_INFO).find(function (_a) {
            var value = _a[1];
            return value.width === size_1.width && value.height === size_1.height;
        });
        if (model) {
            currentData.currentProjectType = model[0];
            console.log("This project is for ".concat(currentData.currentProjectType));
            updateManifest(false, [
                {
                    key: MODEL_INFO[currentData.currentProjectType].propertyData.key,
                    value: rodStartData.backgroundColor.a === 255
                        ? MODEL_INFO[currentData.currentProjectType].propertyData.value
                        : MODEL_INFO[currentData.currentProjectType].propertyData.value |
                            CATEGORY_AOD |
                            CATEGORY_LOCKSCREEN,
                },
            ]);
        }
        else {
            console.error("not found matched model (".concat(size_1.width, "x").concat(size_1.height, ")"));
        }
    }
    else {
        console.log('watch project is opened');
    }
}; };
var onRunOnDeviceFilter = function (currentData) { return function (deviceIds) {
    return new Promise(function (resolve) { return __awaiter(void 0, void 0, void 0, function () {
        var currentProjectModelName, supportedOneUI, filteredInfos, commandPromises, FILTERED_REASON_CLOCKFACE_NOT_INSTALLED, FILTERED_REASON_NOT_SUPPORTED_DEVICE, FILTERED_REASON_NOT_SUPPORTED_ONE_UI_VERSION;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    console.log('onRunOnDeviceFilter deviceIds:', deviceIds);
                    if (wfsSetting.getDeviceProfile() !== 'mobile') {
                        return [2 /*return*/, resolve(undefined)];
                    }
                    currentProjectModelName = MODEL_INFO[currentData.currentProjectType].modelName;
                    supportedOneUI = MODEL_INFO[currentData.currentProjectType].versionOneUI;
                    filteredInfos = [];
                    commandPromises = [];
                    FILTERED_REASON_CLOCKFACE_NOT_INSTALLED = '(ClockFace not installed)';
                    FILTERED_REASON_NOT_SUPPORTED_DEVICE = '(Not supported device)';
                    FILTERED_REASON_NOT_SUPPORTED_ONE_UI_VERSION = '(Not supported One UI version)';
                    deviceIds.map(function (id) { return __awaiter(void 0, void 0, void 0, function () {
                        var checkClockface, checkModel, checkOneUIVersion;
                        return __generator(this, function (_a) {
                            checkClockface = {
                                command: 'sendShell',
                                deviceId: id,
                                options: ['pm', 'list', 'packages', CLOCKFACE_PACKAGE_NAME],
                            };
                            checkModel = {
                                command: 'sendShell',
                                deviceId: id,
                                options: ['getprop', 'ro.product.device'],
                            };
                            checkOneUIVersion = {
                                command: 'sendShell',
                                deviceId: id,
                                options: ['getprop', 'ro.build.version.oneui'],
                            };
                            commandPromises.push(new Promise(function (resolve, reject) {
                                wfsUtil
                                    .sendADBCommand(checkModel)
                                    .then(function (data) {
                                    console.log('Model:', data);
                                    if (!currentProjectModelName.some(function (modelName) { return data.includes(modelName); }) &&
                                        !filteredInfos.some(function (info) { return info.id === id; })) {
                                        filteredInfos.push({
                                            id: id,
                                            filteredReason: FILTERED_REASON_NOT_SUPPORTED_DEVICE,
                                        });
                                    }
                                    resolve();
                                })
                                    .catch(function (err) {
                                    console.error('An error occurred: ', err);
                                    reject();
                                });
                            }));
                            commandPromises.push(new Promise(function (resolve, reject) {
                                wfsUtil
                                    .sendADBCommand(checkClockface)
                                    .then(function (data) {
                                    if (!data.includes(CLOCKFACE_PACKAGE_NAME) &&
                                        !filteredInfos.some(function (info) { return info.id === id; })) {
                                        filteredInfos.push({
                                            id: id,
                                            filteredReason: FILTERED_REASON_CLOCKFACE_NOT_INSTALLED,
                                        });
                                    }
                                    resolve();
                                })
                                    .catch(function (err) {
                                    console.error('An error occurred: ', err);
                                    reject();
                                });
                            }));
                            commandPromises.push(new Promise(function (resolve, reject) {
                                wfsUtil
                                    .sendADBCommand(checkOneUIVersion)
                                    .then(function (data) {
                                    if (!(parseInt(data) >= supportedOneUI) &&
                                        !filteredInfos.some(function (info) { return info.id === id; })) {
                                        filteredInfos.push({
                                            id: id,
                                            filteredReason: FILTERED_REASON_NOT_SUPPORTED_ONE_UI_VERSION,
                                        });
                                    }
                                    resolve();
                                })
                                    .catch(function (err) {
                                    console.error('An error occurred: ', err);
                                    reject();
                                });
                            }));
                            return [2 /*return*/];
                        });
                    }); });
                    return [4 /*yield*/, Promise.allSettled(commandPromises)];
                case 1:
                    _a.sent();
                    console.log('onRunOnDeviceFilter filteredInfo:', filteredInfos);
                    return [2 /*return*/, resolve(filteredInfos)];
            }
        });
    }); });
}; };
var onRunOnDeviceFinished = function (rodData) {
    if (wfsSetting.getDeviceProfile() === 'mobile') {
        console.log('onRunOnDeviceFinished');
        var deviceId_1 = wfsUtil.getSelectedDeviceId();
        var killClockface = {
            command: 'sendShell',
            deviceId: deviceId_1,
            options: ['am', 'force-stop', CLOCKFACE_PACKAGE_NAME],
        };
        wfsUtil
            .sendADBCommand(killClockface)
            .then(function (data) {
            console.log("killClockface: ".concat(data));
            var launchClockface = {
                command: 'sendShell',
                deviceId: deviceId_1,
                options: [
                    'am',
                    'start',
                    '-n',
                    CLOCKFACE_WFS_ACTIVITY_NAME,
                    '--es',
                    CLOCKFACE_INTENT_BUNDLE_KEY_PACKAGE_NAME,
                    rodData.packageName,
                ],
            };
            wfsUtil
                .sendADBCommand(launchClockface)
                .then(function (data) { return console.log("launchClockface: ".concat(data)); })
                .catch(function (err) { return console.log('An error occurred: ', err); });
        })
            .catch(function (err) { return console.log('An error occurred: ', err); });
    }
    return;
};
var addClockFaceSettingBucket = function () {
    buckets.forEach(function (bucket) { return wfsSetting.addSettingBucket(bucket); });
};
var removeClockFaceSettingBucket = function () {
    buckets.forEach(function (bucket) { return wfsSetting.removeSettingBucket(bucket.id); });
};
// Register all the above functions and objects with the relevant extension points
export function init(registerExtensions) {
    console.log("".concat(PLUGIN_NAME, " plugin is initialized"));
    installPreloadedRuntime();
    makeReadOnlySamples();
    addClockFaceSettingBucket();
    var currentData = { currentProjectType: 'Z Flip5' };
    registerExtensions.register('onProjectOpened', 'onProjectOpened', onProjectOpened);
    registerExtensions.register('onProjectClosed', 'onProjectClosed', onProjectClosed);
    registerExtensions.register('onRunOnDeviceStarted', 'onRunOnDeviceStarted', onRunOnDeviceStarted(currentData));
    registerExtensions.register('onRunOnDeviceFilter', 'onRunOnDeviceFilter', onRunOnDeviceFilter(currentData));
    registerExtensions.register('onRunOnDeviceFinished', 'onRunOnDeviceFinished', onRunOnDeviceFinished);
}
// Unregister all the above functions and objects with the relevant extension points
export function deinit() {
    console.log("".concat(PLUGIN_NAME, " plugin is deinitialized"));
    uninstallPreloadedRuntime();
    removeClockFaceSettingBucket();
}
